unit FrmHiveMonitor;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ComCtrls,
  CPortCtl, CPort;

type
  TFormHiveMonitor = class(TForm)
    Panel1: TPanel;
    ButtonStartStop: TButton;
    PageControl1: TPageControl;
    TabCommon: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    LblMainTemp: TLabel;
    LblEvmTemp: TLabel;
    LblTemp1: TLabel;
    LblTemp2: TLabel;
    LblTemp4: TLabel;
    LblTemp3: TLabel;
    LblTemp5: TLabel;
    Label16: TLabel;
    Label8: TLabel;
    Label17: TLabel;
    LblEvmHumidity: TLabel;
    LblHumidity1: TLabel;
    LblHumidity2: TLabel;
    LblHumidity4: TLabel;
    LblHumidity3: TLabel;
    LblHumidity5: TLabel;
    Label25: TLabel;
    LblFan1: TLabel;
    LblFan2: TLabel;
    LblFan4: TLabel;
    LblFan3: TLabel;
    LblFan5: TLabel;
    Label33: TLabel;
    LblBackHeat1: TLabel;
    LblBackHeat2: TLabel;
    LblBackHeat4: TLabel;
    LblBackHeat3: TLabel;
    LblBackHeat5: TLabel;
    Label41: TLabel;
    LblBackTemp1: TLabel;
    LblBackTemp2: TLabel;
    LblBackTemp4: TLabel;
    LblBackTemp3: TLabel;
    LblBackTemp5: TLabel;
    Label49: TLabel;
    LblHarvesting: TLabel;
    Label18: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Shape1: TShape;
    TabSerial: TTabSheet;
    MemConsole: TMemo;
    ComLed1: TComLed;
    ComLed2: TComLed;
    ComLed3: TComLed;
    ComLed4: TComLed;
    Label34: TLabel;
    Label35: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    ComLed5: TComLed;
    ComLed6: TComLed;
    Label50: TLabel;
    Label51: TLabel;
    TabAbout: TTabSheet;
    MemAbout: TMemo;
    ComPort: TComPort;
    LblAllFan: TLabel;
    LblBackHeatTime2: TLabel;
    LblBackHeatTime3: TLabel;
    LblBackHeatTime4: TLabel;
    LblBackHeatTime5: TLabel;
    LblBackHeatTime1: TLabel;
    BtnSettings: TButton;
    Panel2: TPanel;
    ChbWriteToConsole: TCheckBox;
    procedure ComPortAfterClose(Sender: TObject);
    procedure ComPortAfterOpen(Sender: TObject);
    procedure ComPortRxChar(Sender: TObject; Count: Integer);
    procedure ButtonStartStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnSettingsClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    SerialLine : string;
    LastLevel : string;
    procedure ParseLine(Line: string);
  end;

var
  FormHiveMonitor: TFormHiveMonitor;

implementation

{$R *.dfm}

Uses StrUtils;

procedure TFormHiveMonitor.BtnSettingsClick(Sender: TObject);
begin
ComPort.ShowSetupDialog;
end;

procedure TFormHiveMonitor.ButtonStartStopClick(Sender: TObject);
begin
  Try
  if ComPort.Connected then
    ComPort.Close
  else
    ComPort.Open;
  Except
    on E : Exception do
     ShowMessage(E.Message);
  End;
end;

procedure TFormHiveMonitor.ComPortAfterClose(Sender: TObject);
begin
  ButtonStartStop.Caption := 'Start';
end;

procedure TFormHiveMonitor.ComPortAfterOpen(Sender: TObject);
begin
  ButtonStartStop.Caption := 'Stop';
end;

procedure TFormHiveMonitor.ComPortRxChar(Sender: TObject; Count: Integer);
var
  Str: String;
  I : integer;
begin
  ComPort.ReadStr(Str, Count);
  for i := 1 to length(Str) do
    begin
    if (Str[i] = #13) then
      begin
      if (ChbWriteToConsole.Checked) then
         MemConsole.Lines.Add(SerialLine);
      ParseLine(SerialLine);
      SerialLine := '';
      end
     else
    if (Str[i] <> #10) then
      SerialLine := SerialLine + Str[i];
    end;
end;

procedure TFormHiveMonitor.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
if ComPort.Connected then
  ComPort.Close;
CanClose := true;
end;

procedure TFormHiveMonitor.FormCreate(Sender: TObject);
begin
SerialLine := '';
LastLevel := '';
PageControl1.TabIndex := 0
end;

procedure TFormHiveMonitor.ParseLine(Line: string);
var
  tmpStr: string;

  procedure temp(Ctrl: TLabel);
  begin
    if ((StrToFloat(Ctrl.Caption) < 22) or (StrToFloat(Ctrl.Caption) >= 30))
      then Ctrl.Font.Color := clRed
      else Ctrl.Font.Color := clLime;
  end;

  procedure humidity(Ctrl: TLabel);
  begin
    if ((StrToFloat(Ctrl.Caption) < 50) or (StrToFloat(Ctrl.Caption) >= 75))
      then Ctrl.Font.Color := clRed
      else Ctrl.Font.Color := clLime;
  end;

begin
  try
  // All fan
  if (Pos('All Fan on', Line) > 1) then
    begin
    LblAllFan.Font.Color := clLime;
    LblAllFan.Caption := 'ON';
    end;
  if (Pos('All Fan off', Line) > 1) then
    begin
    LblAllFan.Font.Color := clGray;
    LblAllFan.Caption := 'OFF';
    end;

  // Harvesting
  if (Pos('Harvest begain', Line) > 1) then
    begin
    LblHarvesting.Font.Color := clLime;
    LblHarvesting.Caption := 'ON';
    end;
  if (Pos('Harvest stop', Line) > 1) then
    begin
    LblHarvesting.Font.Color := clGray;
    LblHarvesting.Caption := 'OFF';
    end;

  // Evm Evm_temp:269  Evm_humi:321#
  if (Copy(Line, 1, 9) = 'Evm_temp:') then
    begin
    //ShowMessage(Line);
    tmpStr := Copy(Line, 10, 3);
    LblEvmTemp.Caption := FloatToStr(StrToFloat(tmpStr) / 10);
    tmpStr := Copy(Line, 24, 3);
    LblEvmHumidity.Caption := FloatToStr(StrToFloat(tmpStr) / 10);
    end;

  // Main Get_Main_NTC_temp:248
  if (Copy(Line, 1, 18) = 'Get_Main_NTC_temp:') then
    begin
    tmpStr := Copy(Line, 19, 3);
    LblMainTemp.Caption := FloatToStr(StrToFloat(tmpStr) / 10);
    end;

  // LEVEL2  Get_Back_NTC_temp:286
  if (Copy(Line, 1, 5) = 'LEVEL') then
    LastLevel := Copy(Line, 6, 1);
  if (((Copy(Line, 1, 5) = 'LEVEL') or (Copy(Line, 1, 8) = '        ')) and (LastLevel <> '')) then
    begin
    tmpStr := Copy(Line, 9);
    if (Pos('Back_Heat_On', tmpStr) > 0) then
      begin
      TLabel(Self.FindComponent('LblBackHeat' + LastLevel)).Font.Color := clLime;
      TLabel(Self.FindComponent('LblBackHeat' + LastLevel)).Caption := 'ON';
      end;
    if (Pos('Back_Heat_Off', tmpStr) > 0) then
      begin
      TLabel(Self.FindComponent('LblBackHeat' + LastLevel)).Font.Color := clGray;
      TLabel(Self.FindComponent('LblBackHeat' + LastLevel)).Caption := 'OFF';
      end;
    if (Pos('Get_Back_NTC_temp:', tmpStr) > 0) then
      if (Copy(tmpStr, 19, 3) <> '') then
        begin
        TLabel(Self.FindComponent('LblBackTemp' + LastLevel)).Caption := FloatToStr(StrToInt(Copy(tmpStr, 19, 3)) / 10);
        temp(TLabel(Self.FindComponent('LblBackTemp' + LastLevel)));
        end;
    if (Pos('Back_Heat_Time:', tmpStr) > 0) then
      TLabel(Self.FindComponent('LblBackHeatTime' + LastLevel)).Caption := 'last run '+Copy(tmpStr, 16);
    if (Copy(tmpStr, 1, 5) = 'temp:') then
      begin
      TLabel(Self.FindComponent('LblTemp' + LastLevel)).Caption := FloatToStr(StrToInt(Copy(tmpStr, 6, 3)) / 10);
      TLabel(Self.FindComponent('LblHumidity' + LastLevel)).Caption := FloatToStr(StrToInt(Copy(tmpStr, 16, 3)) / 10);
      temp(TLabel(Self.FindComponent('LblTemp' + LastLevel)));
      humidity(TLabel(Self.FindComponent('LblHumidity' + LastLevel)));
      if (Pos('Fan on', tmpStr) > 0) then
        begin
        TLabel(Self.FindComponent('LblFan' + LastLevel)).Font.Color := clLime;
        TLabel(Self.FindComponent('LblFan' + LastLevel)).Caption := 'ON';
        end;
      if (Pos('Fan off', tmpStr) > 0) then
        begin
        TLabel(Self.FindComponent('LblFan' + LastLevel)).Font.Color := clGray;
        TLabel(Self.FindComponent('LblFan' + LastLevel)).Caption := 'OFF';
        end;
      end;
    end;
  Except
    on E : Exception do
     ShowMessage(Line + #13#10 + tmpStr + #13#10 + E.Message);
  end;
end;

end.



